var adSchemaTables = 20; //所定のユーザーがアクセスできるカタログに定義されたテーブル(ビュー含む)を返す
var currentConnection = null;
function openConnection(connStr) {
	currentConnection = new ActiveXObject('ADODB.Connection');
	try {
		currentConnection.Open(connStr);
		//currentConnection.CursorLocation = 3; //件数を取得するため、クライアントサイドカーソルに変更
		return true;
	} catch(e) {
		common_showMsg(common_getExceptionText(e));
		return false;
	}
}
function closeConnection() {
	if (currentConnection && currentConnection.State != adoEnums.objectState.adStateClosed) currentConnection.Close();
	currentConnection = null;
}
function getTableNameList() {
	var recordset = null;
	try {
		recordset = currentConnection.OpenSchema(adSchemaTables)
	} catch(e) {
		common_showMsg(common_getExceptionText(e));
		return false;
	}

	var tableNameArray = [];
	try {
		var tableName = null;
		while(!recordset.EOF) {
			tableName = recordset.Fields('TABLE_NAME').Value;
			//if ('$' == tableName.slice(-1)) tableNameArray.push(tableName); //シート名か判定する場合は末尾に$の有無で見る
			tableNameArray.push(tableName);
			recordset.MoveNext();
		};
		return tableNameArray.sort();
	} catch(e) {
		common_showMsg(common_getExceptionText(e));
	} finally {
		recordset.Close();
		return tableNameArray;
	}
}
function executeGetSchema() {
	var recordset = null;
	try {
		recordset = currentConnection.OpenSchema(adSchemaTables)
	} catch(e) {
		common_showMsg(common_getExceptionText(e));
		return false;
	}
	return editRecordset(recordset);
}
function executeSelectSql(sql) {
	var recordset = null;
	try {
		recordset = currentConnection.Execute(sql);
	} catch(e) {
		common_showMsg(common_getExceptionText(e));
		return;
	}
	return editRecordset(recordset);
}
function editRecordset(recordset) {
	if (recordset.EOF) return;
	var dataArray = [];
	var lineArray = [];
	try {
		for (var i=0 ; i<recordset.Fields.count ; i++) {
			lineArray.push(recordset.Fields(i).Name);
		}
		dataArray.push(lineArray);
		do {
			lineArray = [];
			for (var i=0 ; i<recordset.Fields.count ; i++) {
				lineArray.push(recordset.Fields(i).Value);
			}
			dataArray.push(lineArray);
			recordset.MoveNext();
		} while(!recordset.EOF);
	} catch(e) {
		common_showMsg(common_getExceptionText(e));
	} finally {
		recordset.Close();
		return dataArray;
	}
}
